/*
* JBoss, Home of Professional Open Source
* Copyright 2006, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.test.thread.test;

import junit.framework.AssertionFailedError;

import org.jboss.test.BaseTestCase;
import org.jboss.test.thread.TestThread;

public class TestThreadUnitTestCase extends BaseTestCase
{
   public TestThreadUnitTestCase(String name)
   {
      super(name);
   }
   
   public void testThread()
   {
      TestThread thread = new TestThread("TestThread")
      {
         public void run()
         {
            throw new Error();
         }
      };
      thread.start();
      
      try
      {
         thread.doJoin();
         fail("Should not be here!");
      }
      catch (Throwable t)
      {
         if (t instanceof AssertionFailedError == false)
            failure("Did not get expected error", t);
         Throwable e = t.getCause();
         assertNotNull("Should have a cause", e);
         checkThrowable(Error.class, e);
      }
   }
   
   public void testThreadWithException() throws Exception
   {
      TestThread thread = new TestThread("TestThreadWithException")
      {
         public void run()
         {
            throw new Error();
         }
      };
      thread.start();
      thread.doJoinExpectError(Error.class);
   }
}
